# Filename:     tb_pres_beep.do
# Filetype:     Modelsim Script File
# Date:         9 jul 2014
# Update:       -
# Description:  Script File For Automatic Simulation
# Author:       J. op den Brouw
# State:        Demo
# Error:        -
# Version:      1.0
# Copyright:    (c)2014, De Haagse Hogeschool

# This ModelSim command file houses all commands for tracing
# the client side module driver alias the test hardware.

# Set transcript on
transcript on

# Recreate the work directory and map to work
if {[file exists rtl_work]} {
	vdel -lib rtl_work -all
}
vlib rtl_work
vmap work rtl_work

# Find out if we're started through Quartus or by hand
# (or by using an exec in the Tcl window in Quartus).
# Quartus has the annoying property that it will start
# Modelsim from a directory called "simulation/modelsim".
# The design and the testbench are located in the project
# root, so we've to compensate for that.
if [ string match "*simulation/modelsim" [pwd] ] { 
	set prefix "../../"
	puts "Running Modelsim from Quartus..."
} else {
	set prefix ""
	puts "Running Modelsim..."
}

# Compile the VHDL description and testbench,
# please note that the design and its testbench are located
# in the project root, but the simulator start in directory
# <project_root>/simulation/modelsim, so we have to compensate
# for that.
vcom -2008 -work work ${prefix}pres_beep.vhd
vcom -2008 -work work ${prefix}prescaler32768.vhd
vcom -2008 -work work ${prefix}beeper.vhd
vcom -2008 -work work ${prefix}tb_pres_beep.vhd

# Start the simulator with 1 ps time resolution, load the Altera MF lib
# 1 ps and lib are necessary for simulation
vsim -t 1ps -L rtl_work -L work -L altera_mf -voptargs="+acc" tb_pres_beep
# Log all signals in the design, good if the number
# of signals is small.
add log -r *

# Add all toplevel signals
# Add a number of signals of the simulated design
add wave -divider "SYSTEM"
add wave clk_50MHz
add wave areset
add wave -divider "Inputs"
add wave beep
#add wave -divider "Internals"
add wave -divider "Outputs"
add wave	clk_32768
add wave	locked
#if {[find signals ping] != ""} {
#	add wave ping
#}

# Open Structure, Signals (waveform) and List window
view structure
view signals
view wave

# Run simulation for one clk_32768 period
run 32 us

# Fill up the waveform in the window
wave zoom full
